//INIZIO 2_01_003


//GESTIONE PROVINCE In ANAGRAFICA


call fn_ins_voce_menu('Soggetti Commerciali', 'w_verifica_prov_anag', 'Province Anagrafica', 54);
call fn_ins_voce_menu('Soggetti Commerciali', 'w_verifica_prov_dest', 'Province Destinazioni', 55);

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'provincia')) THEN
	
	CREATE TABLE "dba"."provincia"
               ("id_provincia" integer NOT NULL DEFAULT autoincrement,
              "cod_provincia" char(4) NOT NULL ,
              "des_provincia" char(40) NOT NULL ,
              "regione" char(40) NOT NULL,
              "nazione" char(2) NOT NULL,
	      "cap" char(8)
	       , PRIMARY KEY ("id_provincia")) ;
 
	CREATE UNIQUE INDEX "ix_cod_prov" ON "dba"."provincia" ("cod_provincia" ) ;


	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	1,'AQ','Aquila','Abruzzo','IT','67100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	2,'CH','Chieti','Abruzzo','IT','66100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	3,'PE','Pescara','Abruzzo','IT','65100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	4,'TE','Teramo','Abruzzo','IT','64100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	5,'MT','Matera','Basilicata','IT','85100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	6,'PZ','Potenza','Basilicata','IT','75100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	7,'CZ','Catanzaro','Calabria','IT','88100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	8,'CS','Cosenza','Calabria','IT','87100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	9,'KR','Crotone','Calabria','IT','88900');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	10,'RC','Reggio-Calabria','Calabria','IT','89100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	11,'VV','Vibo-Valentia','Calabria','IT','89900');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	12,'AV','Avellino','Campania','IT','83100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	13,'BN','Benevento','Campania','IT','82100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	14,'CE','Caserta','Campania','IT','81100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	15,'NA','Napoli','Campania','IT','80100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	16,'SA','Salerno','Campania','IT','84100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	17,'BO','Bologna','Emilia Romagna','IT','40100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	18,'FE','Ferrara','Emilia Romagna','IT','44100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	19,'FC','Forli-Cesena','Emilia Romagna','IT','47100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	20,'MO','Modena','Emilia Romagna','IT','41100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	21,'PR','Parma','Emilia Romagna','IT','43100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	22,'PC','Piacenza','Emilia Romagna','IT','29100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	23,'RA','Ravenna','Emilia Romagna','IT','48100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	24,'RE','Reggio-Emilia','Emilia Romagna','IT','42100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	25,'RN','Rimini','Emilia Romagna','IT','47900');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	26,'GO','Gorizia','Friuli Venezia Giulia','IT','34100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	27,'PN','Pordenone','Friuli Venezia Giulia','IT','33100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	28,'TS','Trieste','Friuli Venezia Giulia','IT','34100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	29,'UD','Udine','Friuli Venezia Giulia','IT','33100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	30,'FR','Frosinone','Lazio','IT','03100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	31,'LT','Latina','Lazio','IT','04100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	32,'RI','Rieti','Lazio','IT','02100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	33,'RM','Roma','Lazio','IT','00100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	34,'VT','Viterbo','Lazio','IT','01100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	35,'GE','Genova','Liguria','IT','16100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	36,'IM','Imperia','Liguria','IT','18100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	37,'SP','La-Spezia','Liguria','IT','19100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	38,'SV','Savona','Liguria','IT','17100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	39,'BG','Bergamo','Lombardia','IT','24100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	40,'BS','Brescia','Lombardia','IT','25100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	41,'CO','Como','Lombardia','IT','22100:22100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	42,'CR','Cremona','Lombardia','IT','26100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	43,'LC','Lecco','Lombardia','IT','23900');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	44,'LO','Lodi','Lombardia','IT','26900');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	45,'MN','Mantova','Lombardia','IT','46100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	46,'MI','Milano','Lombardia','IT','20100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	47,'PV','Pavia','Lombardia','IT','27100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	48,'SO','Sondrio','Lombardia','IT','23100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	49,'VA','Varese','Lombardia','IT','21100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	50,'AN','Ancona','Marche','IT','60100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	51,'AP','Ascoli-Piceno','Marche','IT','63100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	52,'MC','Macerata','Marche','IT','62100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	53,'PU','Pesaro-Urbino','Marche','IT','61100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	54,'CB','Campobasso','Molise','IT','86100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	55,'IS','Isernia','Molise','IT','86170');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	56,'AL','Alessandria','Piemonte','IT','15100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	57,'AT','Asti','Piemonte','IT','14100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	58,'BI','Biella','Piemonte','IT','13900');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	59,'CN','Cuneo','Piemonte','IT','12100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	60,'NO','Novara','Piemonte','IT','28100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	61,'TO','Torino','Piemonte','IT','10100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	62,'VB','Verbania','Piemonte','IT','28900');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	63,'VC','Vercelli','Piemonte','IT','13100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	64,'BA','Bari','Puglia','IT','70100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	65,'BR','Brindisi','Puglia','IT','72100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	66,'FG','Foggia','Puglia','IT','71100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	67,'LE','Lecce','Puglia','IT','73100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	68,'TA','Taranto','Puglia','IT','74100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	69,'CA','Cagliari','Sardegna','IT','09100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	70,'NU','Nuoro','Sardegna','IT','08100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	71,'OR','Oristano','Sardegna','IT','09170');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	72,'SS','Sassari','Sardegna','IT','07100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	73,'AG','Agrigento','Sicilia','IT','91100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	74,'CL','Caltanissetta','Sicilia','IT','93100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	75,'CT','Catania','Sicilia','IT','95100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	76,'EN','Enna','Sicilia','IT','94100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	77,'ME','Messina','Sicilia','IT','98100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	78,'PA','Palermo','Sicilia','IT','90100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	79,'RG','Ragusa','Sicilia','IT','97100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	80,'SR','Siracusa','Sicilia','IT','96100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	81,'TP','Trapani','Sicilia','IT','91100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	82,'AR','Arezzo','Toscana','IT','52100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	83,'FI','Firenze','Toscana','IT','50100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	84,'GR','Grosseto','Toscana','IT','58100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	85,'LI','Livorno','Toscana','IT','57100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	86,'LU','Lucca','Toscana','IT','55100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	87,'MS','Massa-Carrara','Toscana','IT','54100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	88,'PI','Pisa','Toscana','IT','56100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	89,'PT','Pistoia','Toscana','IT','51100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	90,'PO','Prato','Toscana','IT','59100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	91,'SI','Siena','Toscana','IT','53100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	92,'BZ','Bolzano','Trentino Alto Adige','IT','39100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	93,'TN','Trento','Trentino Alto Adige','IT','38100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	94,'PG','Perugia','Umbria','IT','06100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	95,'TR','Terni','Umbria','IT','05100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	96,'AO','Aosta','Valle d^Aosta','IT','11100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	97,'BL','Belluno','Veneto','IT','32100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	98,'PD','Padova','Veneto','IT','35100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	99,'RO','Rovigo','Veneto','IT','45100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	100,'TV','Treviso','Veneto','IT','31100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	101,'VE','Venezia','Veneto','IT','30100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	102,'VR','Verona','Veneto','IT','37100');
	insert into provincia ( id_provincia, cod_provincia, des_provincia, regione, nazione,cap) values(	103,'VI','Vicenza','Veneto','IT','36100');


	update anagrafica set anagrafica.provincia='FC'
	where anagrafica.provincia not in (select p.cod_provincia from provincia p)
	and anagrafica.provincia='FO';

	update anagrafica set anagrafica.provincia='PU'
	where anagrafica.provincia not in (select p.cod_provincia from provincia p)
	and anagrafica.provincia='PS';

end if;
//FINE PROVINCIE

//PARTITE - NUOVA FINESTRA
call fn_ins_voce_menu('Gestione Partite', 'w_crea_parscad_sog_ff', 'Stato Partite', 75);
call fn_ins_voce_menu('Gestione Scadenze', 'w_elenco_insoluti_ff', 'Storico Insoluti', 84);


///TABELLE PREVISIONE AGENTE


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'prev_agente')) THEN

	CREATE TABLE "dba"."prev_agente"
                      ("id_prev_agente" integer NOT NULL DEFAULT autoincrement,
                     "anno" integer NOT NULL ,
                     "mese" char(20) NOT NULL ,
                     "id_gruppo_agente" integer NOT NULL ,
                     "previsione" numeric(18,4)
              , PRIMARY KEY ("id_prev_agente")
	       , FOREIGN KEY "fk_budget" ("id_gruppo_agente"
       		) REFERENCES "dba"."gruppo_agenti"
	       ON DELETE  RESTRICT
	) ;
 
	CREATE UNIQUE INDEX "xk_budage"
	        ON "dba"."prev_agente"
	        ("anno" ,
	       "mese" ,
	       "id_prev_agente" ) ;
 
	CREATE UNIQUE INDEX "xpkbudget_agente"
     	   ON "dba"."prev_agente"
        	("id_prev_agente" ) ;
	


	CREATE TABLE "dba"."prev_cl_agente"
                      ("id_prev_cl_agente" integer NOT NULL DEFAULT autoincrement,
                     "anno" integer NOT NULL,
                     "id_sog_commerciale" integer NOT NULL ,
                     "prev_cl" numeric(18,4),
                     "id_gruppo_agente" integer NOT NULL 
              , PRIMARY KEY ("id_prev_cl_agente")
	       , FOREIGN KEY "fk_budget_cl" ("id_sog_commerciale"
	       ) REFERENCES "dba"."sog_commerciale"
	       ON DELETE  RESTRICT
	       , FOREIGN KEY "fk_budget_cl2" ("id_gruppo_agente"
	       ) REFERENCES "dba"."gruppo_agenti"
	       ON DELETE  RESTRICT
	       ) ;
 
	CREATE UNIQUE INDEX "xk_budage_cl"
	        ON "dba"."prev_cl_agente"
	        ("anno" ,
	       "id_sog_commerciale", "id_gruppo_agente" ) ;
	 
	CREATE UNIQUE INDEX "xpkbudget_agente_cl"
	        ON "dba"."prev_cl_agente"
	        ("id_prev_cl_agente" ) ;
	


	CREATE TABLE "dba"."prev_ag_temp"
	        ("id_agente" integer NOT NULL ,
	       "mese" char(12) NOT NULL ,
	       "real_2" numeric(18,4)  ,
	       "real_1" numeric(18,4)  ,
	       "real_0" numeric(18,4)  ,
	       "budget_0" numeric(18,4)  ,
	       "anno" integer  ) ;



	CREATE TABLE "dba"."prev_cl_temp"
	        ("id_agente" integer NOT NULL ,
		"id_sog_commerciale" integer not null,
	       "real_2" numeric(18,4)  ,
	       "real_1" numeric(18,4)  ,
	       "real_0" numeric(18,4)  ,
	       "budget_0" numeric(18,4)  ,
	       "anno" integer  ) ;
	


	CREATE TABLE "dba"."prev_cl_cat" ("id_prev_cl_cat" integer NOT NULL DEFAULT autoincrement, "anno" integer NOT NULL DEFAULT NULL,
	 "id_sog_commerciale" integer NOT NULL DEFAULT NULL, "prev_cl" numeric(18,4) DEFAULT NULL, 
	"id_cat" integer NOT NULL DEFAULT NULL , PRIMARY KEY ("id_prev_cl_cat")  ) ;
	CREATE UNIQUE INDEX "xk_budage_cl_cat" ON "dba"."prev_cl_cat" ("anno" , "id_sog_commerciale" ) ;
	CREATE UNIQUE INDEX "xpkbudget_agente_cl_cat" ON "dba"."prev_cl_cat" ("id_prev_cl_cat" ) ;

	CREATE TABLE "dba"."prev_cat" ("id_prev_cat" integer NOT NULL DEFAULT autoincrement, "anno" integer NOT NULL DEFAULT NULL, "mese" char(20) NOT NULL DEFAULT NULL, "id_cat" integer NOT NULL DEFAULT NULL, "previsione" numeric(18,4) DEFAULT NULL , PRIMARY KEY ("id_prev_cat")) ;
	CREATE UNIQUE INDEX "xk_budcat" ON "dba"."prev_cat" ("anno" , "mese" , "id_prev_cat" ) ;
	CREATE UNIQUE INDEX "xpkbudget_cat" ON "dba"."prev_cat" ("id_prev_cat" ) ;
	//call fn_ins_voce_menu('Agenti', 'w_agente_prev_budget_cx', 'Previsione Agente', 75);
end if;
//FINE AGENTE


ALTER FUNCTION "DBA"."fn_esi_lotti"(in @id_lotto integer,in @id_magazzino integer,in @fino_al date,in @id_valuta_f integer)
returns char(80)
begin
  /*
  Elisa Moneti  05/06/2001      BL#13259#
  07/02/2002      BL#18197#

  Calcolo:
  . 	"Esistenza Fiscale" (Carichi - Scarichi)

  Argomenti input:
  . ID Lotto    (Obbligatorio)
  . ID Magazzino	(Obbligatorio, se 0 tutti i magazzini)
  . Fino Al     (Obbligatorio)

  Valore di ritorno:
  . 1 - 20 	carattere --> Esistenza Fisica
  */
  //
  //
  declare @ld_carichi decimal(18,4);
  declare @ld_scarichi decimal(18,4);
  declare @ls_carichi char(20);
  declare @ls_scarichi char(20);
  declare @ld_costo_acquisto decimal(18,4);
  declare @ls_costo_acquisto char(20);
  /* Valori di ritorno */
  declare @ld_esi_fisica decimal(18,4);
  declare @ls_esi_fisica char(20);
  declare @ls_tipo_mov char(1);
  //
  select m.tipo into @ls_tipo_mov
    from unita_confezione as u,unita_misura as m,lotto as l
    where l.id_lotto=@id_lotto
    and u.id_articolo=l.id_articolo
    and u.unita_base='S'
    and m.id_unita_misura=u.id_unita_misura;
  //
  message ' Tipo Movimentazione:'+@ls_tipo_mov;
  //
  if(@ls_tipo_mov='P') then
    if @id_magazzino=0 then
      /* 
      Calcolo l''Esistenza Fisica Totale a Peso
      */
      //      select(Sum(ifnull(r.peso_netto,0,r.peso_netto))),"Max"(r.prezzo_netto) 
      select(Sum(ifnull(r.peso_netto,0,r.peso_netto))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi,
        @ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
        where l.id_lotto=@id_lotto
        and rl.id_lotto=l.id_lotto
        and r.id_riga_lotto=rl.id_riga_lotto
        and c.id_caus_magazzino=r.id_caus_magazzino
        and c.gestisce_lotti='C'
        and d.id_documento=r.id_documento
        and d.data_registrazione<=@fino_al;
      //
      message ' CARICHI A PESO:'+string(@ld_carichi)+' COSTO ACQ.:'+string(@ld_costo_acquisto);
      //
      select(Sum(ifnull(r.peso_netto,0,r.peso_netto))) into @ld_scarichi
        from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
        where l.id_lotto=@id_lotto
        and rl.id_lotto=l.id_lotto
        and r.id_riga_lotto=rl.id_riga_lotto
        and c.id_caus_magazzino=r.id_caus_magazzino
        and c.gestisce_lotti='S'
        and d.id_documento=r.id_documento
        and d.data_registrazione<=@fino_al;
      //
      message ' SCARICHI A PESO:'+string(@ld_scarichi)
    end if
  else //
    //
    /* 
    Calcolo l''Esistenza Fisica Totale a Peso
    */
    //    select(Sum(ifnull(r.quantita,0,r.quantita))),"Max"(r.prezzo_netto) into @ld_carichi,
    select(Sum(ifnull(r.quantita,0,r.quantita))),"Max"(fn_conv_valuta(r.id_valuta,r.prezzo_netto,@id_valuta_f)) into @ld_carichi,
      @ld_costo_acquisto from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
      where l.id_lotto=@id_lotto
      and rl.id_lotto=l.id_lotto
      and r.id_riga_lotto=rl.id_riga_lotto
      and c.id_caus_magazzino=r.id_caus_magazzino
      and c.gestisce_lotti='C'
      and d.id_documento=r.id_documento
      and d.data_registrazione<=@fino_al;
    //
    message ' CARICHI A QUANTITA:'+string(@ld_carichi)+' COSTO ACQ.:'+string(@ld_costo_acquisto);
    //
    //
    select(Sum(ifnull(r.quantita,0,r.quantita))) into @ld_scarichi
      from lotto as l,riga_doc_lotto as rl,riga_documento as r,documento as d,caus_magazzino as c
      where l.id_lotto=@id_lotto
      and rl.id_lotto=l.id_lotto
      and r.id_riga_lotto=rl.id_riga_lotto
      and c.id_caus_magazzino=r.id_caus_magazzino
      and c.gestisce_lotti='S'
      and d.id_documento=r.id_documento
      and d.data_registrazione<=@fino_al;
    //
    message ' SCARICHI A QUANTITA:'+string(@ld_scarichi)
  end if //
  ; //
  set @ld_esi_fisica=ifnull(@ld_carichi,0,@ld_carichi)-ifnull(@ld_scarichi,0,@ld_scarichi);
  message ' CARICHI:'+string(@ld_carichi)+' SCARICHI:'+string(@ld_scarichi)+' COSTO ACQ.:'+string(@ld_costo_acquisto);
  /* 
  Costruisco ls stringa di ritorno 
  */
  /* Esistenza Fisica */
  set @ls_esi_fisica=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_esi_fisica,0,@ld_esi_fisica))))+STRING(ifnull(@ld_esi_fisica,0,@ld_esi_fisica));
  /* Carichi */
  set @ls_carichi=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_carichi,0,@ld_carichi))))+STRING(ifnull(@ld_carichi,0,@ld_carichi));
  /* Scarichi */
  set @ls_scarichi=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_scarichi,0,@ld_scarichi))))+STRING(ifnull(@ld_scarichi,0,@ld_scarichi));
  /* Costo Acquisto */
  set @ls_costo_acquisto=REPEAT(' ',20-LENGTH(STRING(ifnull(@ld_costo_acquisto,0,@ld_costo_acquisto))))+STRING(ifnull(@ld_costo_acquisto,0,@ld_costo_acquisto));
  //
  return(STRING(@ls_esi_fisica,@ls_carichi,@ls_scarichi,@ls_costo_acquisto))
end;

ALTER PROCEDURE "DBA"."fn_cod_barre_art"(@id_articolo integer)
as
begin
  /*
  Elisa Moneti
  05/07/1999

  Calcolo:
  . 	"Esistenza fisica" in base ai parametri di esistenza specificati
  nella tabella PAR_ESISTENZA.
  . 	"Esistenza Fiscale" (Carichi - Scarichi)
  . 	"Costo Medio" (Valore Caricato / Quantit Scaricata)

  Argomenti input:
  . ID Articolo

  Valore di ritorno:
  . 1  - 5		carattere --> ID tipo codice a barre
  . 6 - 26		carattere --> codice a barre
  . 27 - 27  	carattere --> generazione automatica
  */
  declare @ls_return char(27),
  @ls_id_tipo_cod_barre char(5),
  @ll_id_tipo_cod_barre integer,
  @ls_codice char(20),
  @ls_gen_automatica char(1)
  declare c_cod_barre_art dynamic scroll cursor for select c.id_tipo_cod_barre,c.codice,c.gen_automatica
      from cod_barre as c,unita_confezione as u
      where u.id_articolo=@id_articolo
      and u.unita_base='S'
      and c.id_unita_confezione=u.id_unita_confezione
  open c_cod_barre_art
  fetch next c_cod_barre_art into @ll_id_tipo_cod_barre,@ls_codice,
    @ls_gen_automatica
  close c_cod_barre_art
  if @@rowcount>0
    begin
      select @ls_id_tipo_cod_barre=STRING(@ll_id_tipo_cod_barre)
      message ' Riga recuperata --> Des.:'+@ls_id_tipo_cod_barre+' Cod.:'+@ls_codice+' Gen. A.:'+@ls_gen_automatica
    end
  /* 
  Costruisco ls stringa di ritorno 
  */
  while(LENGTH(@ls_id_tipo_cod_barre)<5)
    select @ls_id_tipo_cod_barre=STRING(' ',@ls_id_tipo_cod_barre)
  while(LENGTH(@ls_codice)<20)
    select @ls_codice=STRING(@ls_codice,' ')
  select @ls_return=@ls_id_tipo_cod_barre
  /*+@ls_codice+@ls_gen_automatica*/
  return(@ls_return)
end;

///////AGGIORNAMENTO WEB
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'nome_cognome' )) THEN 
        alter table web_ordine_t add nome_cognome char(60) DEFAULT NULL;          
end if;  

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'indirizzo' )) THEN 
        alter table web_ordine_t add "indirizzo" char(60) DEFAULT NULL;          
end if;   

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'cap' )) THEN 
        alter table web_ordine_t add "cap" char(5) DEFAULT NULL;          
end if;  

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'localita' )) THEN 
        alter table web_ordine_t add "localita" char(30) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'prov' )) THEN 
        alter table web_ordine_t add "prov" char(2) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'piva' )) THEN 
        alter table web_ordine_t add "piva" char(16) DEFAULT NULL;          
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'cfisc' )) THEN 
        alter table web_ordine_t add "cfisc" char(16) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'telefono' )) THEN 
        alter table web_ordine_t add "telefono" char(20) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'cellulare' )) THEN 
        alter table web_ordine_t add "cellulare" char(20) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'fax' )) THEN 
        alter table web_ordine_t add "fax" char(20) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'username' )) THEN 
        alter table web_ordine_t add "username" char(20) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'web_ordine_t'
                  AND      CNAME = 'password' )) THEN 
        alter table web_ordine_t add "password" char(20) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   web_ruoli
        WHERE  codice = 'GUEST')) THEN 
				insert into web_ruoli (codice, descrizione)
				values ('GUEST', 'GUEST');
end if;
///////AGGIORNAMENTO WEB


//PER DEMO
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'par_sistema'
                  AND      CNAME = 'usa_demo' )) THEN 
	alter table par_sistema add usa_demo char(1);
end if;


IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSTABLE
        WHERE  TABLE_NAME = 'contatto')) THEN
	
	CREATE TABLE "dba"."contatto" ("id_contatto" integer NOT NULL DEFAULT autoincrement,
			   "tipo_contatto" char(1) NOT NULL DEFAULT NULL, 
			   "rag_soc_1" char(256) NOT NULL DEFAULT NULL, 
			   "rag_soc_2" char(256) DEFAULT NULL, 
			   "par_iva" char(16) NOT NULL DEFAULT NULL, 
			   "mail" char(256) NOT NULL DEFAULT NULL, "cap" char(10) NOT NULL DEFAULT NULL, 
			   "prov" char(2) NOT NULL DEFAULT NULL, 
                           "nazione" char(20) NOT NULL DEFAULT NULL, 
			   "indirizzo" char(256) NOT NULL DEFAULT NULL, 
                           "localita" char(256) NOT NULL DEFAULT NULL, 
                           "data_contatto" date DEFAULT NULL , PRIMARY KEY ("id_contatto")) ; 

	CREATE UNIQUE INDEX "pk_mail" ON "dba"."contatto" ("mail" ) ;
	CREATE UNIQUE INDEX "pk_par_iva" ON "dba"."contatto" ("par_iva" ) ;
end if;



//FINE

//FAX azienda
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'azienda'
                  AND      CNAME = 'fax_amministrazione' )) THEN 
	alter table azienda add fax_amministrazione char(20);
end if;                                 

///////


call fn_ins_voce_menu('Documenti', 'w_agg_prz', 'Ricalcolo Prezzi Documenti', 120);
call fn_ins_voce_menu('Documenti', 'w_gen_ordfor_cx', 'Generazione Ordini a Fornitore', 130);


////Riorganizzazione Menu
Delete from voci_menu where vmenu_voce='Categorie Commerciali';
Delete from voci_menu where vmenu_voce='Categorie Zona';
Delete from voci_menu where vmenu_voce='Categorie Attivit';

Delete from voci_menu where vmenu_voce='Categorie'
and id_voci_menu_padre in (select p.id_voci_menu from voci_menu p where p.vmenu_voce='Dati Azienda');

call fn_ins_voce_menu('Dati Azienda', 'w_cat_attivita_gd', 'Categorie Attivit', 3);
call fn_ins_voce_menu('Anagrafica', 'w_cat_zona_gd', 'Categorie Zona', 4);
call fn_ins_voce_menu('Anagrafica', 'w_cat_com_sc_gd', 'Categorie Commerciale', 5);

Delete from voci_menu where vmenu_voce='Anagrafiche Condivise';
Delete from voci_menu where vmenu_voce='Agendina Telefonica';
Delete from voci_menu where vmenu_voce='Ricerca Anag. per Sogg. Comm.';
Delete from voci_menu where vmenu_voce='Variazione dati Sogg. Comm.';
Delete from voci_menu where vmenu_voce='Province Anagrafica';
Delete from voci_menu where vmenu_voce='Province Destinazioni';

Delete from voci_menu where vmenu_voce='Soggetti Commerciali'
and id_voci_menu_padre in (select p.id_voci_menu from voci_menu p where p.vmenu_voce='Anagrafica');

call fn_ins_voce_menu('Anagrafica', 'w_anag_2_cx', 'Anagrafiche Condivise', 1);
call fn_ins_voce_menu('Anagrafica', 'w_tel_sempl_cx', 'Agenda Telefonica', 2);
call fn_ins_voce_menu('Anagrafica', 'w_verifica_prov_anag', 'Province Anagrafica', 9);
call fn_ins_voce_menu('Anagrafica', 'w_verifica_prov_dest', 'Province Destinazioni', 10);
call fn_ins_voce_menu('Anagrafica', 'w_anagrafica_dett_ff', 'Stampa Anagrafica', 11);
call fn_ins_voce_menu('Anagrafica', 'w_var_dati_sc_cx', 'Variazione Dati Anagrafica', 20);

update voci_menu set vmenu_order=8 where vmenu_voce='Piano dei Conti';
update voci_menu set vmenu_order=7 where vmenu_voce='Invio @_mail';

call fn_ins_voce_menu('Anagrafica', 'w_anagrafica_etic_ff', 'Stampa Etichette', 12);

//Riorganizzazione Fine

//Parigi per causale NMN su derivazione distinte base
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
                  AND      CNAME = 'nmn_derdist' )) THEN 
	alter table pers_par_sistema add nmn_derdist char(1);
end if;                                 

//////////////////////PARIGI TRASF. ORDINI da PORTATILE
IF EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_dati') THEN

   DROP procedure sp_trasf_dati
	;
END IF;

CREATE PROCEDURE "DBA"."sp_trasf_dati"(@ai_tipo_trasferimento integer,@ai_num_parte integer)
begin
  if(@ai_tipo_trasferimento=1) then
    if(@ai_num_parte=5) then
      message 'So 1';
      call sp_trasf_bossi()
    end if
    ;

    if(@ai_num_parte=4) then
      call sp_trasf_parte4();
      call sp_trasf_parte4_1()
    end if
    ;

    if(@ai_num_parte=0) or(@ai_num_parte=1) then
      call sp_trasf_parte1();
      call sp_trasf_parte1_1()
    end if
    ;
    if(@ai_num_parte=0) or(@ai_num_parte=2) then
      call sp_trasf_parte2();
      call sp_trasf_parte2_1()
    end if
    ;
    if(@ai_num_parte=0) or(@ai_num_parte=3) then
      call sp_trasf_parte3();
      set option fire_triggers='off';
      call sp_trasf_parte3_1();
      set option fire_triggers='on'
    end if
  /*
  Trasferimento Dati "Cometa - Cometa"
  2 = creazione tmp anagrafiche
  2_1 = allineamento anagrafiche
  1 = creazione tmp documenti
  1_1 = allineamento bolle di vendita
  3_1 = allineamento fatture di vendita
  */
  elseif(@ai_tipo_trasferimento=3) then
    if(@ai_num_parte=0) then
      call sp_trasf_cometa_parte2();
      call sp_trasf_cometa_parte2_1();
      call sp_trasf_cometa_parte1();
      call sp_trasf_cometa_parte1_1()
    elseif(@ai_num_parte=1) then
      call sp_trasf_cometa_parte2();
      call sp_trasf_cometa_parte2_1()
    elseif(@ai_num_parte=3) then
      call sp_trasf_cometa_parte2();
      call sp_trasf_cometa_parte2_1();
      call sp_trasf_cometa_parte1();
      call sp_trasf_cometa_parte3_1()
    elseif(@ai_num_parte=7) then
      call sp_trasf_cometa_parte7();
      call sp_trasf_cometa_parte7_1()
    end if
  end if
end;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte7') THEN

CREATE PROCEDURE "DBA"."sp_trasf_cometa_parte7"()
begin

  declare @li_record integer;
  //
  if(not(exists(select 1 from sys.systable where table_name='tmp_log'))) then
    create global temporary table "dba".tmp_log(
      id integer not null default autoincrement,
      note long varchar null,
      primary key(id),
      ) on commit preserve rows
  end if
  ;

  if(exists(select 1 from sys.systable where table_name='tmp_documento')) then
    drop table tmp_documento
  end if
  ;
 
  create global temporary table
    "dba".tmp_documento(
    id_documento integer not null,
    id_prof_documento integer not null,
    id_registro integer not null,
    num_progressivo decimal(12) not null,
    data_registrazione date not null,
    num_documento char(16) null,
    data_documento date null,
    data_competenza date null,
    id_prof_registrazione integer null,
    des_contabile char(40) null,
    id_sog_commerciale integer not null,
    id_destinazione integer null,
    id_caus_magazzino integer null,
    id_magazzino integer null,
    id_magazzino_2 integer null,
    id_sog_commerciale_fattura integer null,
    id_lingua integer null,
    id_linguaggio integer null,
    id_valuta integer not null,
    cambio decimal(8,4) null,
    id_listino integer null,
    id_con_pagamento integer null,
    id_gruppo_agenti integer null,
    id_banca_sog_commerciale integer null,
    origine char(40) null,
    interlocutore char(40) null,
    data_prev_consegna date null,
    note_intestazione long varchar null,
    num_colli decimal(8) null,
    id_unita_misura_peso integer null,
    peso_netto decimal(18,4) null default 0,
    peso_lordo decimal(18,4) null default 0,
    id_unita_misura_volume integer null,
    volume decimal(18,4) null default 0,
    id_tipo_trasporto integer null,
    id_caus_trasporto integer null,
    asp_beni char(40) null,
    tras_mezzo char(1) null,
    id_sog_commerciale_vettore integer null,
    id_sog_commerciale_vettore_2 integer null,
    mezzo_trasporto char(40) null,
    targa_mezzo_trasporto char(40) null,
    data_trasporto date null,
    ora_trasporto time null,
    sconto_finanziario char(40) null,
    sconto_fin_incondizionato decimal(18,4) null,
    sconto_fin_cassa decimal(5,2) null,
    data_dec_pagamento date null,
    imp_acconto decimal(18,4) null,
    id_tipo_pagamento integer null,
    stampato char(1) null,
    contabilizzato char(1) null,
    evaso_totalmente char(1) null,
    chius_forzata char(1) null,
    sospeso char(1) null,
    data_scadenza date null,
    creato_in_esenzione char(1) null,
    bloccato char(1) null,
    prog_globale decimal(16) null,
    doc_globale decimal(16) null,
    tipo_fattura char(1) null,
    segno_iva decimal(2) null default 1,
    id_documento_padre integer null,
    id_azienda integer not null default 1,
    id_tipo_pag_acconto integer null,
    id_tab_iva_acconto integer null,
    id_val_acconto integer null,
    ora_registrazione time null,
    id_locazione_1 integer null,
    id_locazione_2 integer null,
    storno_anticipi char(1) null,
    id_variazione integer null,
    bollo char(20) null,
    id_gruppo_agenti_2 integer null,
    data_ric_consegna date null,
    num_riga integer null,
    id_utente integer null,
    primary key(id_documento),
    ) on commit preserve rows;
  //
  create unique index xak1tmp_documento on
    "dba".tmp_documento(id_registro asc,num_progressivo asc,data_registrazione asc);
  //
  load into table tmp_documento from 'C:\\windows\\temp\\documento.txt' format 'ASCII' delimited by ';' quotes off;
  //
  commit work;
  //
  select "count"(*) into @li_record
    from tmp_documento;
  //
  message 'tabella TMP DOCUMENTO record trasferiti:'+string(@li_record);
  //
  /*
  BOLLE DI VENDITA - RIGHE
  */
  if(exists(select 1 from sys.systable where table_name='tmp_riga_documento')) then
    drop table tmp_riga_documento
  end if
  ;
  create global temporary table "dba".tmp_riga_documento(
    id_riga_documento integer not null,
    id_documento integer null,
    id_unita_confezione integer null,
    id_gruppo_agenti integer null,
    num_riga decimal(4) null,
    id_articolo integer null,
    descrizione long varchar null,
    id_des_articolo integer null,
    quantita decimal(18,4) null,
    qta_sconto_merce decimal(18,4) null,
    qta_evasa decimal(18,4) null,
    fat_con_unita_base decimal(8,4) null,
    fat_con_globale decimal(8,4) null,
    qta_un_base decimal(18,4) null,
    qta_evasa_un_base decimal(18,4) null,
    id_caus_magazzino integer null,
    id_locazione_1 integer null,
    id_locazione_2 integer null,
    id_valuta integer null,
    cambio decimal(8,4) null,
    id_listino integer null,
    id_con_lis_articolo integer null,
    prezzo decimal(18,4) null,
    sconto char(40) null,
    prezzo_netto decimal(18,4) null,
    sconto_riga decimal(18,4) null,
    data_prevista_consegna date null,
    peso_netto decimal(18,4) null,
    peso_lordo decimal(18,4) null,
    dim_l decimal(18,4) null,
    dim_h decimal(18,4) null,
    dim_p decimal(18,4) null,
    num_colli decimal(8) null,
    id_tab_iva integer null,
    val_attribuito decimal(18,4) null,
    provv_agente decimal(5,2) null,
    provv_subage decimal(5,2) null,
    provv_carea decimal(5,2) null,
    id_caus_trasporto integer null,
    forza_chius_evasione char(1) null,
    sospesa char(1) null,
    da_stampare char(1) null,
    data_inizio_competenza date null,
    data_fine_competenza date null,
    tot_riga_val_riga decimal(18,4) null,
    tot_riga_val_doc decimal(18,4) null,
    tot_riga_val_az decimal(18,4) null,
    id_riga_doc_provenienza integer null,
    id_conto integer null,
    id_azienda integer null,
    id_riga_doc_padre integer null,
    provv_imp_agente decimal(18,4) null,
    provv_imp_subage decimal(18,4) null,
    provv_imp_carea decimal(18,4) null,
    id_riga_lotto integer null,
    qta_ordinata_fo decimal(18,4) null,
    ordinato_fo char(1) null,
    peso_netto_evaso decimal(18,4) null,
    id_gruppo_Agenti_2 integer null,
    provv_agente_2 decimal(5,2) null,
    provv_subage_2 decimal(5,2) null,
    provv_carea_2 decimal(5,2) null,
    provv_imp_agente_2 decimal(18,4) null,
    provv_imp_subage_2 decimal(18,4) null,
    provv_imp_carea_2 decimal(18,4) null,
    id_art_var1 integer null,
    id_art_var2 integer null,
    id_art_var3 integer null,
    id_distinta integer null,
    primary key(id_riga_documento),
    ) on commit preserve rows;
  //
  create unique index ak1_tmp_riga_documento on tmp_riga_documento(id_documento asc,num_riga asc);
  load into table tmp_riga_documento from 'C:\\windows\\temp\\riga_documento.txt' format 'ASCII' delimited by ';' quotes off;
  //
  commit work;
  //
  select "count"(*) into @li_record
    from tmp_riga_documento;
  //
  message 'tabella TMP RIGA DOCUMENTO record trasferiti:'+string(@li_record);
  //
  /*
  BOLLE DI VENDITA - CASTELLETTO IVA
  */
  if(exists(select 1 from sys.systable where table_name='tmp_cast_iva_documento')) then
    drop table tmp_cast_iva_documento
  end if
  ;
  create global temporary table "dba".tmp_cast_iva_documento(
    id_documento integer not null,
    id_tab_iva integer not null,
    val_omaggi decimal(18,4) null,
    val_imponibile decimal(18,4) null,
    val_imp_scontato decimal(18,4) null,
    val_spese decimal(18,4) null,
    val_tot_imp_v decimal(18,4) null,
    val_tot_imp_l decimal(18,4) null,
    val_tot_iva_v decimal(18,4) null,
    val_tot_iva_l decimal(18,4) null,
    primary key(id_documento,id_tab_iva),
    ) on commit preserve rows;
  //
  load into table tmp_cast_iva_documento from 'C:\\windows\\temp\\cast_iva_documento.txt' format 'ASCII' delimited by ';' quotes off;
  //
  commit work;
  //
  select "count"(*) into @li_record
    from tmp_cast_iva_documento;
  //
  message 'tabella TMP CAST IVA DOCUMENTO record trasferiti:'+string(@li_record);
  //
  /*
  BOLLE DI VENDITA - CASTELLETTO CONTROPARTITE
  */
  if(exists(select 1 from sys.systable where table_name='tmp_cast_cpt_documento')) then
    drop table tmp_cast_cpt_documento
  end if
  ;
  //
  create global temporary table "dba".tmp_cast_cpt_documento(
    id_documento integer not null,
    id_conto integer not null,
    tipo_riga_cpt char(1) null,
    val_imponibile decimal(18,4) null,
    val_imp_scontato decimal(18,4) null,
    val_omaggi decimal(18,4) null,
    val_spese decimal(18,4) null,
    primary key(id_documento,id_conto),
    ) on commit preserve rows;
  //
  load into table tmp_cast_cpt_documento from 'C:\\windows\\temp\\cast_cpt_documento.txt' format 'ASCII' delimited by ';' quotes off;
  //
  commit work;
  //
  select "count"(*) into @li_record
    from tmp_cast_cpt_documento;
  //
  message 'tabella TMP CAST CPT DOCUMENTO record trasferiti:'+string(@li_record);
  //
  /*
  BOLLE DI VENDITA - SPESE DOCUMENTO
  */
  if(exists(select 1 from sys.systable where table_name='tmp_spesa_documento')) then
    drop table tmp_spesa_documento
  end if
  ;
  //
  create global temporary table "dba".tmp_spesa_documento(
    id_documento integer not null,
    id_spesa integer not null,
    percentuale decimal(5,2) null,
    importo decimal(18,4) null,
    id_tab_iva integer null,
    primary key(id_documento,
    id_spesa),
    ) on commit preserve rows;
  //
  message 'tabella TMP SPESA DOCUMENTO Inizio Load:';
  load into table tmp_spesa_documento from 'C:\\windows\\temp\\spesa_documento.txt' format 'ASCII' delimited by ';' quotes off;
  //
  commit work;
  //
  select "count"(*) into @li_record
    from tmp_spesa_documento;
  //
  message 'tabella TMP SPESA DOCUMENTO record trasferiti:'+string(@li_record);
  //
  /*
  BOLLE DI VENDITA - SCADENZE
  */
  if(exists(select 1 from sys.systable where table_name='tmp_scadenza')) then
    drop table tmp_scadenza
  end if
  ;
  //
  create global temporary table "dba".tmp_scadenza(
    id_scadenza integer not null,
    tipo_scadenza char(1) null,
    id_sog_commerciale integer null,
    data_scadenza date null,
    id_valuta integer null,
    cambio decimal(8,4) null,
    imp_valuta decimal(18,4) null,
    importo decimal(18,4) null,
    id_tipo_pagamento integer null,
    id_banca_azienda integer null,
    id_banca_sog_commerciale integer null,
    note long varchar null,
    ces_denominazione char(40) null,
    ces_indirizzo char(40) null,
    ces_cap char(10) null,
    ces_localita char(40) null,
    ces_provincia char(5) null,
    ces_doc_originale char(16) null,
    ces_data_documento date null,
    stato_scadenza char(1) null,
    data_cambiamento_stato date null,
    esito_pagamento char(1) null,
    scadenza_da_raggruppare char(1) null,
    id_riga_distinta_banca integer null,
    id_documento integer null,
    id_par_aperta integer null,
    id_scadenza_padre integer null,
    id_azienda integer null,
    cod_sog_commerciale char(8) null,
    primary key(id_scadenza),
    ) on commit preserve rows;
  //
  load into table tmp_scadenza from 'C:\\windows\\temp\\scadenza.txt' format 'ASCII' delimited by ';' quotes off;
  //
  commit work;
  //
  select "count"(*) into @li_record
    from tmp_scadenza;
  //
  message 'tabella TMP SCADENZA record trasferiti:'+string(@li_record);
  //
  message 'FINE LOAD ... ';
  message 'INIZIO CREAZIONE INDICI PK ... ';
  //
  create unique index xpk_tmp_documento on tmp_documento(id_documento asc);
  //
  create unique index xpk_tmp_riga_documento on tmp_riga_documento(id_riga_documento asc);
  //
  message 'FINE CREAZIONE INDICI PK ... '
//
end;

END IF
;

IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'sp_trasf_cometa_parte7_1') THEN

CREATE PROCEDURE "DBA"."sp_trasf_cometa_parte7_1"()
on exception resume

begin
  declare err_notfound exception for sqlstate value '02000';
  declare invalid_foreign_key exception for sqlstate value '23503';
  declare row_not_found exception for sqlstate value '02000';
  declare ok exception for sqlstate value '00000';
  declare column_cannot_be_null exception for sqlstate value '23502';
  declare @ls_message char(80);
  declare @li_id_doc_app integer;
  declare @ll_num_suggerito_min integer; 
  declare @ll_num_suggerito_max integer; 
  declare @ld_data_prec date; 
  declare @ld_data_succ date;
  declare @data_registrazione2 date;
  declare li_errori integer;
  declare @li_id_pdc integer;
  declare @li_id_valuta integer;
  declare @li_sqlstatus integer;
  declare @li_doc_letti integer;
  declare @li_doc_inseriti integer;
  declare @errore decimal;
  declare @id_documento_new integer;
  declare @ld_data_ric_consegna date;
  declare @li_num_riga integer;
  /* Variabili per Fetch della testa del documento */
  declare @id_documento integer;
  declare @id_prof_documento integer;
  declare @id_registro integer;
  declare @num_progressivo decimal(12);
  declare @num_progressivo2 decimal(12);
  declare @data_registrazione date;
  declare @num_documento char(16);
  declare @data_documento date;
  declare @data_competenza date;
  declare @id_prof_registrazione integer;
  declare @des_contabile char(40);
  declare @id_sog_commerciale integer;
  declare @id_destinazione integer;
  declare @id_caus_magazzino integer;
  declare @id_magazzino integer;
  declare @id_magazzino_2 integer;
  declare @id_sog_commerciale_fattura integer;
  declare @id_lingua integer;
  declare @id_linguaggio integer;
  declare @id_valuta integer;
  declare @cambio decimal(8,4);
  declare @id_listino integer;
  declare @id_con_pagamento integer;
  declare @id_gruppo_agenti integer;
  declare @id_banca_sog_commerciale integer;
  declare @origine char(40);
  declare @interlocutore char(40);
  declare @data_prev_consegna date;
  declare @note_intestazione long varchar;
  declare @num_colli decimal(8);
  declare @id_unita_misura_peso integer;
  declare @peso_netto decimal(18,4);
  declare @peso_lordo decimal(18,4);
  declare @id_unita_misura_volume integer;
  declare @volume decimal(18,4);
  declare @id_tipo_trasporto integer;
  declare @id_caus_trasporto integer;
  declare @asp_beni char(40);
  declare @tras_mezzo char(1);
  declare @id_sog_commerciale_vettore integer;
  declare @id_sog_commerciale_vettore_2 integer;
  declare @mezzo_trasporto char(40);
  declare @targa_mezzo_trasporto char(40);
  declare @data_trasporto date;
  declare @ora_trasporto time;
  declare @sconto_finanziario char(40);
  declare @sconto_fin_incondizionato decimal(18,4);
  declare @sconto_fin_cassa decimal(5,2);
  declare @data_dec_pagamento date;
  declare @imp_acconto decimal(18,4);
  declare @id_tipo_pagamento integer;
  declare @stampato char(1);
  declare @contabilizzato char(1);
  declare @evaso_totalmente char(1);
  declare @chius_forzata char(1);
  declare @sospeso char(1);
  declare @data_scadenza date;
  declare @creato_in_esenzione char(1);
  declare @bloccato char(1);
  declare @prog_globale decimal(16);
  declare @doc_globale decimal(16);
  declare @tipo_fattura char(1);
  declare @segno_iva decimal(2);
  declare @id_documento_padre integer;
  declare @id_azienda integer;
  declare @ID_Tipo_Pag_Acconto integer;
  declare @ID_Tab_Iva_Acconto integer;
  declare @ID_Val_Acconto integer;
  declare @ora_registrazione time;
  declare @id_locazione_1 integer;
  declare @id_locazione_2 integer;
  declare @storno_anticipi char(1);
  declare @id_variazione integer;
  declare @bollo char(20);
  declare @id_gruppo_Agenti_2 integer;
  declare @id_utente integer;
  declare @cod_sog_commerciale char(8); //BL#10859#  
  declare @cod_sog_commerciale_fattura char(8); //BL#10859#    
  declare @cod_sog_commerciale_vettore char(8); //BL#10859#    
  declare @cod_sog_commerciale_vettore_2 char(8); //BL#10859#      
  declare @cod_caus_magazzino char(8);
  declare @rag_soc_1_des char(40);
  declare @rag_soc_2_des char(40);
  declare @indirizzo_des char(40);
  declare @cod_mag_1 char(8);
  declare @cod_mag_2 char(8);
  declare @cod_listino char(8);
  declare @cod_con_pagamento char(8);
  declare @rag_soc_1 char(40);
  declare @rag_soc_2 char(40);
  declare @cod_abi char(5);
  declare @cod_cab char(5);
  declare @corsia_loc1 char(5);
  declare @scaffale_loc1 char(5);
  declare @ripiano_loc1 char(5);
  declare @posizione_loc1 char(5);
  declare @corsia_loc2 char(5);
  declare @scaffale_loc2 char(5);
  declare @ripiano_loc2 char(5);
  declare @posizione_loc2 char(5);
  declare @cod_mag_loc1 char(8);
  declare @cod_area_loc1 char(8);
  declare @cod_mag_loc2 char(8);
  declare @cod_area_loc2 char(8);
  declare @ls_sqlstate char(10);
  /*
  Cursore per la testa del documento
  */
  declare cur_documento dynamic scroll cursor for select tmp_documento.id_documento,
      tmp_documento.id_prof_documento,
      tmp_documento.id_registro,
      tmp_documento.num_progressivo,
      tmp_documento.data_registrazione,
      tmp_documento.num_documento,
      tmp_documento.data_documento,
      tmp_documento.data_competenza,
      tmp_documento.id_prof_registrazione,
      tmp_documento.des_contabile,
      tmp_documento.id_sog_commerciale,
      tmp_documento.id_destinazione,
      tmp_documento.id_caus_magazzino,
      tmp_documento.id_magazzino,
      tmp_documento.id_magazzino_2,
      tmp_documento.id_sog_commerciale_fattura,
      tmp_documento.id_lingua,
      tmp_documento.id_linguaggio,
      tmp_documento.id_valuta,
      tmp_documento.cambio,
      tmp_documento.id_listino,
      tmp_documento.id_con_pagamento,
      tmp_documento.id_gruppo_agenti,
      tmp_documento.id_banca_sog_commerciale,
      tmp_documento.origine,
      tmp_documento.interlocutore,
      tmp_documento.data_prev_consegna,
      tmp_documento.note_intestazione,
      tmp_documento.num_colli,
      tmp_documento.id_unita_misura_peso,
      tmp_documento.peso_netto,
      tmp_documento.peso_lordo,
      tmp_documento.id_unita_misura_volume,
      tmp_documento.volume,
      tmp_documento.id_tipo_trasporto,
      tmp_documento.id_caus_trasporto,
      tmp_documento.asp_beni,
      tmp_documento.tras_mezzo,
      tmp_documento.id_sog_commerciale_vettore,
      tmp_documento.id_sog_commerciale_vettore_2,
      tmp_documento.mezzo_trasporto,
      tmp_documento.targa_mezzo_trasporto,
      tmp_documento.data_trasporto,
      tmp_documento.ora_trasporto,
      tmp_documento.sconto_finanziario,
      tmp_documento.sconto_fin_incondizionato,
      tmp_documento.sconto_fin_cassa,
      tmp_documento.data_dec_pagamento,
      tmp_documento.imp_acconto,
      tmp_documento.id_tipo_pagamento,
      tmp_documento.stampato,
      tmp_documento.contabilizzato,
      tmp_documento.evaso_totalmente,
      tmp_documento.chius_forzata,
      tmp_documento.sospeso,
      tmp_documento.data_scadenza,
      tmp_documento.creato_in_esenzione,
      tmp_documento.bloccato,
      tmp_documento.prog_globale,
      tmp_documento.doc_globale,
      tmp_documento.tipo_fattura,
      tmp_documento.segno_iva,
      tmp_documento.id_documento_padre,
      tmp_documento.id_azienda,
      tmp_documento.ID_Tipo_Pag_Acconto,
      tmp_documento.ID_Tab_Iva_Acconto,
      tmp_documento.ID_Val_Acconto,
      tmp_documento.ora_registrazione,
      tmp_documento.id_locazione_1,
      tmp_documento.id_locazione_2,
      tmp_documento.storno_anticipi,
      tmp_documento.id_variazione,
      tmp_documento.bollo,
      tmp_documento.id_gruppo_Agenti_2,
      tmp_documento.data_ric_consegna,
      tmp_documento.num_riga,
      tmp_documento.id_utente
      from tmp_documento;
  /**/
  //set option FIRE_TRIGGERS='OFF';
  insert into tmp_log(note) values('');
  insert into tmp_log(note) values('Data Trasferimento: '+string(dateformat(today(*),'dd-mm-yyyy')));
  insert into tmp_log(note) values('');
  insert into tmp_log(note) values('INIZIO TRASFERIMENTO ORDINI - '+string(dateformat(Now(*),'hh:mm:ss')));
  insert into tmp_log(note) values('*********************************************************************************');
  commit work;
  open cur_documento;
  /**/
  //  message ' RECORD LETTI DAL CURSORE:'+string(@@rowcount);
  /**/
  set @li_sqlstatus=0;
  set @li_doc_letti=0;
  set @li_doc_inseriti=0;
  lp1:
  while(@li_sqlstatus<>2) loop
    fetch next cur_documento into @id_documento,
      @id_prof_documento,
      @id_registro,
      @num_progressivo,
      @data_registrazione,
      @num_documento,
      @data_documento,
      @data_competenza,
      @id_prof_registrazione,
      @des_contabile,
      @id_sog_commerciale,
      @id_destinazione,
      @id_caus_magazzino,
      @id_magazzino,
      @id_magazzino_2,
      @id_sog_commerciale_fattura,
      @id_lingua,
      @id_linguaggio,
      @id_valuta,
      @cambio,
      @id_listino,
      @id_con_pagamento,
      @id_gruppo_agenti,
      @id_banca_sog_commerciale,
      @origine,
      @interlocutore,
      @data_prev_consegna,
      @note_intestazione,
      @num_colli,
      @id_unita_misura_peso,
      @peso_netto,
      @peso_lordo,
      @id_unita_misura_volume,
      @volume,
      @id_tipo_trasporto,
      @id_caus_trasporto,
      @asp_beni,
      @tras_mezzo,
      @id_sog_commerciale_vettore,
      @id_sog_commerciale_vettore_2,
      @mezzo_trasporto,
      @targa_mezzo_trasporto,
      @data_trasporto,
      @ora_trasporto,
      @sconto_finanziario,
      @sconto_fin_incondizionato,
      @sconto_fin_cassa,
      @data_dec_pagamento,
      @imp_acconto,
      @id_tipo_pagamento,
      @stampato,
      @contabilizzato,
      @evaso_totalmente,
      @chius_forzata,
      @sospeso,
      @data_scadenza,
      @creato_in_esenzione,
      @bloccato,
      @prog_globale,
      @doc_globale,
      @tipo_fattura,
      @segno_iva,
      @id_documento_padre,
      @id_azienda,
      @ID_Tipo_Pag_Acconto,
      @ID_Tab_Iva_Acconto,
      @ID_Val_Acconto,
      @ora_registrazione,
      @id_locazione_1,
      @id_locazione_2,
      @storno_anticipi,
      @id_variazione,
      @bollo,
      @id_gruppo_Agenti_2,
      @ld_data_ric_consegna,
      @li_num_riga,
      @id_utente;
    set @li_sqlstatus=@@sqlstatus;
    message ' SQLSTATUS:'+STRING(@li_sqlstatus);
    /**/
    if(@li_sqlstatus=0) then // fetch
      set @li_doc_letti=@li_doc_letti+1;
      message ' RECORD LETTI:'+string(@li_doc_letti);
      /* Inserimento documento */
      set @num_progressivo2 = null;
      set @data_registrazione2 = null;
      call sp_Ges_NumProg_DataReg(0, @id_registro, @num_progressivo2, @data_registrazione2, @ls_message, @ll_num_suggerito_min, @ll_num_suggerito_max, @ld_data_prec, @ld_data_succ, @li_id_doc_app);

      insert into documento(id_prof_documento,
        id_registro,
        num_progressivo,
        data_registrazione,
        num_documento,
        data_documento,
        data_competenza,
        id_prof_registrazione,
        des_contabile,
        id_sog_commerciale,
        id_destinazione,
        id_caus_magazzino,
        id_magazzino,
        id_magazzino_2,
        id_sog_commerciale_fattura,
        id_lingua,
        id_linguaggio,
        id_valuta,
        cambio,
        id_listino,
        id_con_pagamento,
        id_gruppo_agenti,
        id_banca_sog_commerciale,
        origine,
        interlocutore,
        data_prev_consegna,
        note_intestazione,
        num_colli,
        id_unita_misura_peso,
        peso_netto,
        peso_lordo,
        id_unita_misura_volume,
        volume,
        id_tipo_trasporto,
        id_caus_trasporto,
        asp_beni,
        tras_mezzo,
        id_sog_commerciale_vettore,
        id_sog_commerciale_vettore_2,
        mezzo_trasporto,
        targa_mezzo_trasporto,
        data_trasporto,
        ora_trasporto,
        sconto_finanziario,
        sconto_fin_incondizionato,
        sconto_fin_cassa,
        data_dec_pagamento,
        imp_acconto,
        id_tipo_pagamento,
        stampato,
        contabilizzato,
        evaso_totalmente,
        chius_forzata,
        sospeso,
        data_scadenza,
        creato_in_esenzione,
        bloccato,
        prog_globale,
        doc_globale,
        tipo_fattura,
        segno_iva,
        id_documento_padre,
        id_azienda,
        ID_Tipo_Pag_Acconto,
        ID_Tab_Iva_Acconto,
        ID_Val_Acconto,
        ora_registrazione,
        id_locazione_1,
        id_locazione_2,
        storno_anticipi,
        id_variazione,
        bollo,
        id_gruppo_Agenti_2,
        data_ric_consegna,
        num_riga,
        id_utente) values(
        @id_prof_documento,
        @id_registro,
        @num_progressivo2,
        @data_registrazione,
        @num_progressivo2,
        @data_registrazione,
        @data_competenza,
        @id_prof_registrazione,
        @des_contabile,
        @id_sog_commerciale,
        @id_destinazione,
        @id_caus_magazzino,
        @id_magazzino,
        @id_magazzino_2,
        @id_sog_commerciale_fattura,
        @id_lingua,
        @id_linguaggio,
        @id_valuta,
        @cambio,
        @id_listino,
        @id_con_pagamento,
        @id_gruppo_agenti,
        @id_banca_sog_commerciale,
        @origine,
        @interlocutore,
        @data_prev_consegna,
        @note_intestazione,
        @num_colli,
        @id_unita_misura_peso,
        @peso_netto,
        @peso_lordo,
        @id_unita_misura_volume,
        @volume,
        @id_tipo_trasporto,
        @id_caus_trasporto,
        @asp_beni,
        @tras_mezzo,
        @id_sog_commerciale_vettore,
        @id_sog_commerciale_vettore_2,
        @mezzo_trasporto,
        @targa_mezzo_trasporto,
        @data_trasporto,
        @ora_trasporto,
        @sconto_finanziario,
        @sconto_fin_incondizionato,
        @sconto_fin_cassa,
        @data_dec_pagamento,
        @imp_acconto,
        @id_tipo_pagamento,
        @stampato,
        @contabilizzato,
        @evaso_totalmente,
        @chius_forzata,
        @sospeso,
        @data_scadenza,
        @creato_in_esenzione,
        @bloccato,
        @prog_globale,
        @doc_globale,
        @tipo_fattura,
        @segno_iva,
        @id_documento_padre,
        1,
        @ID_Tipo_Pag_Acconto,
        @ID_Tab_Iva_Acconto,
        @ID_Val_Acconto,
        @ora_registrazione,
        @id_locazione_1,
        @id_locazione_2,
        @storno_anticipi,
        @id_variazione,
        @bollo,
        @id_gruppo_Agenti_2,
        @ld_data_ric_consegna,
        @li_num_riga,
        @id_utente);
      set @ls_sqlstate=sqlstate;
      message 'SQLSTATE:'+@ls_sqlstate+' Documento:'+string(@id_documento);
      set @id_documento_new=@@identity;
      if(@id_documento_new is null) then
        message 'ID DOCUMENTO NEW E'' NULL'
      end if
      ;
      message ' ID DOCUMENTO NEW:'+STRING(@id_documento_new);
      //      if(@@error=0) then
      message 'SQLSTATE:'+@ls_sqlstate+' Documento New:'+string(@id_documento_new);
      if(@ls_sqlstate='00000') and(@id_documento_new>0) then
        //        commit work;
        message '--SQLSTATE:'+@ls_sqlstate;
        /* ID del documento inserito */
        /**/
        message 'DOCUMENTO Id Cava:'+string(@id_documento)+' Id Sede:'+string(@id_documento_new)+' Prot/Data:'+string(@num_progressivo)+'  '+string(@data_registrazione)+' - record trasferiti:'+string(@@rowcount);
        insert into tmp_log(note) values('DOCUMENTO Id Cava:'+string(@id_documento)+' Id Sede:'+string(@id_documento_new)+' Prot/Data:'+string(@num_progressivo)+'  '+string(@data_registrazione)+' - record trasferiti:'+string(@@rowcount));
        /**/
        set @li_doc_inseriti=@li_doc_inseriti+1;
        /* CAST IVA DOCUMENTO
        Per ogni documento inserito correttamente, inserisco i relativi record di 
        CAST_IVA_DOCUMENTO associandole al nuovo ID Documento assegnato al record.
        */
        insert into cast_iva_documento(id_documento,
          id_tab_iva,
          val_omaggi,
          val_imponibile,
          val_imp_scontato,
          val_spese,
          val_tot_imp_v,
          val_tot_imp_l,
          val_tot_iva_v,
          val_tot_iva_l)
          select @id_documento_new,
            id_tab_iva,
            val_omaggi,
            val_imponibile,
            val_imp_scontato,
            val_spese,
            val_tot_imp_v,
            val_tot_imp_l,
            val_tot_iva_v,
            val_tot_iva_l
            from tmp_cast_iva_documento
            where id_documento=@id_documento;
        set @ls_sqlstate=sqlstate;
        //      if(@@error=0) then
        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
          message '   CAST IVA DOCUMENTO - record trasferiti:'+string(@@rowcount);
          insert into tmp_log(note) values('   CAST IVA DOCUMENTO - record trasferiti:'+string(@@rowcount))
        else
          message '   Si e'' verificato un errore importando le righe del Castelletto Iva del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
          insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe del Castelletto Iva del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
        end if
        ; /* CAST CPT DOCUMENTO
        Per ogni documento inserito correttamente, inserisco i relativi record di 
        CAST_CPT_DOCUMENTO associandole al nuovo ID Documento assegnato al record.
        */
        insert into cast_cpt_documento(id_documento,
          id_conto,
          tipo_riga_cpt,
          val_imponibile,
          val_imp_scontato,
          val_omaggi,
          val_spese)
          select @id_documento_new,
            id_conto,
            tipo_riga_cpt,
            val_imponibile,
            val_imp_scontato,
            val_omaggi,
            val_spese
            from tmp_cast_cpt_documento
            where id_documento=@id_documento;
        set @ls_sqlstate=sqlstate;
        //      if(@@error=0) then
        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
          message '   CAST CPT DOCUMENTO - record trasferiti:'+string(@@rowcount);
          insert into tmp_log(note) values('   CAST CPT DOCUMENTO - record trasferiti:'+string(@@rowcount))
        else
          message '   Si e'' verificato un errore importando le righe del Castelletto Contropartita del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
          insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe del Castelletto Contropartita del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
        end if
        ; /* SPESA DOCUMENTO
        Per ogni documento inserito correttamente, inserisco i relativi record di 
        SPESA_DOCUMENTO associandole al nuovo ID Documento assegnato al record.
        */
        insert into spesa_documento(id_documento,
          id_spesa,
          percentuale,
          importo,
          id_tab_iva)
          select @id_documento_new,
            id_spesa,
            tmp_spesa_documento.percentuale,
            tmp_spesa_documento.importo,
            id_tab_iva
            from tmp_spesa_documento
            where id_documento=@id_documento;
        set @ls_sqlstate=sqlstate;
        //      if(@@error=0) then
        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
          message '   SPESA DOCUMENTO - record trasferiti:'+string(@@rowcount);
          insert into tmp_log(note) values('   SPESA DOCUMENTO - record trasferiti:'+string(@@rowcount))
        else
          if(@ls_sqlstate<>'02000') then
            message '   Si e'' verificato un errore importando le righe delle spese del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
            insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe delle spese del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
          end if
        end if
        ; /* SCADENZA
        Per ogni documento inserito correttamente, inserisco i relativi record di 
        SCADENZA associandole al nuovo ID Documento assegnato al record.
        */
        insert into scadenza(tipo_scadenza,
          id_sog_commerciale,
          data_scadenza,
          id_valuta,
          cambio,
          imp_valuta,
          importo,
          id_tipo_pagamento,
          id_banca_azienda,
          id_banca_sog_commerciale,
          note,
          ces_denominazione,
          ces_indirizzo,
          ces_cap,
          ces_localita,
          ces_provincia,
          ces_doc_originale,
          ces_data_documento,
          stato_scadenza,
          data_cambiamento_stato,
          esito_pagamento,
          scadenza_da_raggruppare,
          id_riga_distinta_banca,
          id_documento,
          id_par_aperta,
          id_scadenza_padre,
          id_azienda)
          select tipo_scadenza,
            id_sog_commerciale,
            data_scadenza,
            id_valuta,
            cambio,
            imp_valuta,
            importo,
            id_tipo_pagamento,
            null, //id_banca_azienda,
            id_banca_sog_commerciale,
            //id_banca_sog_commerciale,
            note,
            ces_denominazione,
            ces_indirizzo,
            ces_cap,
            ces_localita,
            ces_provincia,
            ces_doc_originale,
            ces_data_documento,
            stato_scadenza,
            data_cambiamento_stato,
            esito_pagamento,
            scadenza_da_raggruppare,
            null, //id_riga_distinta_banca,
            @id_documento_new,
            null, //id_par_aperta,
            null, //id_scadenza_padre,
            1
            from tmp_scadenza
            where id_documento=@id_documento;
        set @ls_sqlstate=sqlstate;
        //      if(@@error=0) then
        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
          message '   SCADENZA - record trasferiti:'+string(@@rowcount);
          insert into tmp_log(note) values('   SCADENZA - record trasferiti:'+string(@@rowcount))
        else
          if(@ls_sqlstate<>'02000') then
            message '   Si e'' verificato un errore importando le righe delle scadenze del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
            insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe delle scadenze del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
          end if
        end if
        ;
        /* RIGA DOCUMENTO 
        Per ogni documento inserito correttamente, inserisco le righe 
        associandole al nuovo ID Documento assegnato al record.
        */
        set @ls_sqlstate='';
        insert into riga_documento(id_documento,
          id_unita_confezione,
          id_gruppo_agenti,
          num_riga,
          id_articolo,
          descrizione,
          id_des_articolo,
          quantita,
          qta_sconto_merce,
          qta_evasa,
          fat_con_unita_base,
          fat_con_globale,
          qta_un_base,
          qta_evasa_un_base,
          id_caus_magazzino,
          id_locazione_1,
          id_locazione_2,
          id_valuta,
          cambio,
          id_listino,
          id_con_lis_articolo,
          prezzo,
          sconto,
          prezzo_netto,
          sconto_riga,
          data_prevista_consegna,
          peso_netto,
          peso_lordo,
          dim_l,
          dim_h,
          dim_p,
          num_colli,
          id_tab_iva,
          val_attribuito,
          provv_agente,
          provv_subage,
          provv_carea,
          id_caus_trasporto,
          forza_chius_evasione,
          sospesa,
          da_stampare,
          data_inizio_competenza,
          data_fine_competenza,
          tot_riga_val_riga,
          tot_riga_val_doc,
          tot_riga_val_az,
          id_riga_doc_provenienza,
          id_conto,
          id_azienda,
          id_riga_doc_padre,
          provv_imp_agente,
          provv_imp_subage,
          provv_imp_carea,
          id_riga_lotto,
          qta_ordinata_fo,
          ordinato_fo,
          peso_netto_evaso,
          id_gruppo_Agenti_2,
          provv_agente_2,
          provv_subage_2,
          provv_carea_2,
          provv_imp_agente_2,
          provv_imp_subage_2,
          provv_imp_carea_2)
          select @id_documento_new,
            tr.id_unita_confezione,
            tr.id_gruppo_agenti,
            tr.num_riga,
            tr.id_articolo,
            tr.descrizione,
            null,
            tr.quantita,
            tr.qta_sconto_merce,
            tr.qta_evasa,
            tr.fat_con_unita_base,
            tr.fat_con_globale,
            tr.qta_un_base,
            tr.qta_evasa_un_base,
            tr.id_caus_magazzino,
            tr.id_locazione_1,
            tr.id_locazione_2,
            tr.id_valuta,
            tr.cambio,
            null,
            null,
            tr.prezzo,
            tr.sconto,
            tr.prezzo_netto,
            tr.sconto_riga,
            tr.data_prevista_consegna,
            tr.peso_netto,
            tr.peso_lordo,
            tr.dim_l,
            tr.dim_h,
            tr.dim_p,
            tr.num_colli,
            tr.id_tab_iva,
            tr.val_attribuito,
            tr.provv_agente,
            tr.provv_subage,
            tr.provv_carea,
            tr.id_caus_trasporto,
            tr.forza_chius_evasione,
            tr.sospesa,
            tr.da_stampare,
            tr.data_inizio_competenza,
            tr.data_fine_competenza,
            tr.tot_riga_val_riga,
            tr.tot_riga_val_doc,
            tr.tot_riga_val_az,
            null,
            tr.id_conto,
            1,
            null,
            tr.provv_imp_agente,
            tr.provv_imp_subage,
            tr.provv_imp_carea,
            null,
            tr.qta_ordinata_fo,
            tr.ordinato_fo,
            tr.peso_netto_evaso,
            tr.id_gruppo_agenti,
            tr.provv_agente_2,
            tr.provv_subage_2,
            tr.provv_carea_2,
            tr.provv_imp_agente_2,
            tr.provv_imp_subage_2,
            tr.provv_imp_carea_2
            from tmp_riga_documento as tr
            where tr.id_documento=@id_documento;
        set @ls_sqlstate=sqlstate;
        message 'SQLSTATE:'+@ls_sqlstate+' Riga Documento:'+string(@id_documento);
        if(@ls_sqlstate='00000' or @ls_sqlstate='02000') then
          message '   RIGHE DOCUMENTO - record trasferiti:'+string(@@rowcount);
          insert into tmp_log(note) values('   RIGHE DOCUMENTO - record trasferiti:'+string(@@rowcount))
        else
          message '   Si e'' verificato un errore importando le righe del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate;
          insert into tmp_log(note) values('   Si e'' verificato un errore importando le righe del documento '+string(@id_documento_new)+' SQLSTATE:'+@ls_sqlstate)
        end if
      else
        /**/
        // l''Inserimento di un record in DOCUMENTO + andato in errore
        rollback work;
        message ' 3) @ls_sqlstate:'+@ls_sqlstate;
        if(@ls_sqlstate='23503') then
          message '     Verificare che i riferimenti alle anagrafiche siano allineati (cond. di pagamento ecc..)';
          insert into tmp_log(note) values('     Verificare che i riferimenti alle anagrafiche siano allineati (cond. di pagamento ecc..)')
        elseif(@ls_sqlstate='23502') then
          message '     Colonna NULL';
          insert into tmp_log(note) values('     Colonna NULL')
        else
          message 'Si e'' verificato un errore importando il documento Id Cava:'+string(@id_documento)+' SQLSTATE:'+@ls_sqlstate;
          insert into tmp_log(note) values('Si e'' verificato un errore importando il documento Id Cava:'+string(@id_documento)+' SQLSTATE:'+@ls_sqlstate)
        end if
      end if
    end if
  end loop lp1
  ;
  //set option FIRE_TRIGGERS='ON';
  // Loop della FETCH
  message ' SQLSTATUS 3:'+STRING(@li_sqlstatus);
  message 'TABELLA DOCUMENTO - record trasferiti:'+string(@li_doc_inseriti);
  insert into tmp_log(note) values('TABELLA DOCUMENTO record trasferiti: '+string(@li_doc_inseriti));
  message 'TABELLA DOCUMENTO record trasferiti: '+string(@li_doc_inseriti);
  insert into tmp_log(note) values('*********************************************************************************');
  message '*********************************************************************************';
  insert into tmp_log(note) values('FINE TRASFERIMENTO BOLLE DI VENDITA - '+string(dateformat(Now(*),'hh:mm:ss')));
  message 'FINE TRASFERIMENTO BOLLE DI VENDITA - '+string(dateformat(Now(*),'hh:mm:ss'));
  commit work;
  set ls_sqlstate=sqlstate;
  message ' 5) @ls_sqlstate commit:'+@ls_sqlstate;
  close cur_documento;
  set ls_sqlstate=sqlstate;
  message ' 4) @ls_sqlstate close cursore:'+@ls_sqlstate;
  message ' SQLSTATUS 4:'+STRING(@li_sqlstatus);
  select "COUNT"(*) into li_errori
    from tmp_log
    where note like '%SQLSTATE%';
  //
  if(li_errori>0) then
    insert into tmp_log(note) values('Controllare il report, il trasferimento e'' terminato con '+string(li_errori)+' errori')
  end if
  ;
  commit work
//
end;
END IF;
///////////////////////////////////////////////////////

//////////////ERREZETA per stampa ordini fornitore
IF NOT EXISTS(
        SELECT 1 
        FROM   SYS.SYSPROCEDURE
        WHERE  PROC_NAME = 'fn_des_Articolo') THEN

CREATE function "DBA"."fn_des_Articolo"(in @id_articolo integer,in @id_sog_com integer, in @id_rig_doc integer)
returns char(100)
//on exception resume
begin

  declare @codice char(32);
  declare @descrizione char(60);
  declare @articolo char(100);
		
  select codice, descrizione
  into @codice, @descrizione
  from des_articolo
  where id_articolo = @id_articolo
  and id_sog_commerciale = @id_sog_com;
  if sqlcode<>0 then
     select a.codice, r.descrizione
     into @codice, @descrizione
     from articolo a, riga_documento r
     where r.id_articolo = a.id_articolo
     and r.id_riga_documento = @id_rig_doc;
     if sqlcode<>0 then
	select ' ', descrizione
        into @codice, @descrizione
        from riga_documento
        where id_riga_documento = @id_rig_doc;
     end if;
  end if;
  set @codice = @codice + REPEAT(' ', 18-LENGTH(@codice));
  return(@codice + ' ' + @descrizione)

end; // end procedura
END IF;
//////////////////////////////////////////////////

////////////VETRERIA LV
//Calcolo addizionale energetica
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'vetro'
                  AND      CNAME = 'spessore' )) THEN 
        alter table vetro add "spessore" integer DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
                  AND      CNAME = 'add_ener_vetro' )) THEN 
        alter table pers_par_sistema add "add_ener_vetro" numeric(18,4) DEFAULT NULL;          
end if;
////////////////////////

///////////////////Duplicazione Documenti
//eliminata duplicazione informazioni relative alla derivazione
ALTER FUNCTION "DBA"."fn_dup_documento"(in @ai_id_documento integer,in @ad_num_progressivo decimal(12),in @ad_prog_globale decimal(16),in @ai_id_prof_doc integer,in @ai_id_registro integer,in @ai_id_caus_mag integer)
returns integer
begin
  declare @li_id_documento_new integer;
  declare @ls_sqlstate char(5);
  declare row_not_found exception for sqlstate value '02000';
  declare ok exception for sqlstate value '00000';
  declare @li_id_locazione_1_prop integer;
  //
  
  select id_locazione_1_prop
  into @li_id_locazione_1_prop
  from prof_documento 
  where id_prof_documento = @ai_id_prof_doc;
  
  
  message 'Inizio fn_dup_documento';
  message ' Duplicazione del Documento:'+string(@ai_id_documento);
  if(@ai_id_prof_doc=0 or @ai_id_registro=0 or @ai_id_caus_mag=0) then
    insert into documento(id_prof_documento,id_registro,num_progressivo,
      data_registrazione,num_documento,data_documento,data_competenza,
      id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
      id_caus_magazzino,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
      id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
      id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
      data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
      peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
      id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
      id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
      data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
      sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,
      stampato,contabilizzato,evaso_totalmente,chius_forzata,
      sospeso,data_scadenza,creato_in_esenzione,bloccato,prog_globale,
      doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
      ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
      id_locazione_1,id_locazione_2,storno_anticipi,id_variazione)
      select id_prof_documento,id_registro,@ad_num_progressivo,
        data_registrazione,num_documento,data_documento,data_competenza,
        id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
        @ai_id_caus_mag,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
        id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
        id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
        data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
        peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
        id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
        id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
        data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
        sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,'N','N','N','N','N',
        data_scadenza,creato_in_esenzione,'N',@ad_prog_globale,
        doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
        ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
        id_locazione_1,id_locazione_2,storno_anticipi,id_variazione
        from documento
        where id_documento=@ai_id_documento
  else
    insert into documento(id_prof_documento,id_registro,num_progressivo,
      data_registrazione,num_documento,data_documento,data_competenza,
      id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
      id_caus_magazzino,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
      id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
      id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
      data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
      peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
      id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
      id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
      data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
      sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,
      stampato,contabilizzato,evaso_totalmente,chius_forzata,
      sospeso,data_scadenza,creato_in_esenzione,bloccato,prog_globale,
      doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
      ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
      id_locazione_1,id_locazione_2,storno_anticipi,id_variazione)
      select @ai_id_prof_doc,@ai_id_registro,@ad_num_progressivo,
        data_registrazione,num_documento,data_documento,data_competenza,
        id_prof_registrazione,des_contabile,id_sog_commerciale,id_destinazione,
        id_caus_magazzino,id_magazzino,id_magazzino_2,id_sog_commerciale_fattura,
        id_lingua,id_linguaggio,id_valuta,cambio,id_listino,id_con_pagamento,
        id_gruppo_agenti,id_banca_sog_commerciale,origine,interlocutore,
        data_prev_consegna,note_intestazione,num_colli,id_unita_misura_peso,
        peso_netto,peso_lordo,id_unita_misura_volume,volume,id_tipo_trasporto,
        id_caus_trasporto,asp_beni,tras_mezzo,id_sog_commerciale_vettore,
        id_sog_commerciale_vettore_2,mezzo_trasporto,targa_mezzo_trasporto,
        data_trasporto,ora_trasporto,sconto_finanziario,sconto_fin_incondizionato,
        sconto_fin_cassa,data_dec_pagamento,imp_acconto,id_tipo_pagamento,'N','N','N','N','N',
        data_scadenza,creato_in_esenzione,'N',@ad_prog_globale,
        doc_globale,tipo_fattura,segno_iva,id_documento_padre,id_azienda,
        ID_Tipo_Pag_Acconto,ID_Tab_Iva_Acconto,ID_Val_Acconto,ora_registrazione,
        id_locazione_1,id_locazione_2,storno_anticipi,id_variazione
        from documento
        where id_documento=@ai_id_documento
  end if
  ;
  set @ls_sqlstate=sqlstate;
  message 'aabbbb';
  if(@ls_sqlstate='00000') then
    message ' OK'
  else
    message '   Si e'' verificato un errore inserendo il documento - SQLSTATE:'+@ls_sqlstate;
    return 0
  end if
  ;
  //
  message 'aaa';
  //
  set @li_id_documento_new=@@identity;
  //
  message ' Documento Inserito:'+string(@li_id_documento_new);
  //
  if(@ai_id_prof_doc=0 or @ai_id_registro=0 or @ai_id_caus_mag=0) then
    insert into riga_documento(id_documento,id_unita_confezione,id_gruppo_agenti,
      num_riga,id_articolo,descrizione,id_des_articolo,quantita,
      qta_sconto_merce,qta_evasa,fat_con_unita_base,fat_con_globale,
      qta_un_base,qta_evasa_un_base,id_caus_magazzino,id_locazione_1,id_locazione_2,
      id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
      sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
      peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
      provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
      sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
      tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
      id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
      provv_imp_subage,provv_imp_carea,id_riga_lotto,
      qta_ordinata_fo,ordinato_fo,peso_netto_evaso,id_gruppo_Agenti_2,
      provv_agente_2,provv_subage_2,provv_carea_2,
      provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2)
      select @li_id_documento_new,id_unita_confezione,id_gruppo_agenti,
        num_riga,id_articolo,descrizione,id_des_articolo,quantita,
        qta_sconto_merce,qta_evasa,fat_con_unita_base,fat_con_globale,
        qta_un_base,qta_evasa_un_base,id_caus_magazzino,id_locazione_1,id_locazione_2,
        id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
        sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
        peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
        provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
        sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
        tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
        id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
        provv_imp_subage,provv_imp_carea,id_riga_lotto,
        qta_ordinata_fo,ordinato_fo,peso_netto_evaso,id_gruppo_Agenti_2,
        provv_agente_2,provv_subage_2,provv_carea_2,
        provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2
        from riga_documento
        where id_documento=@ai_id_documento order by
        num_riga asc
  else
    
      if(@li_id_locazione_1_prop=0 or @li_id_locazione_1_prop is null) then
        insert into riga_documento(id_documento,id_unita_confezione,id_gruppo_agenti,
          num_riga,id_articolo,descrizione,id_des_articolo,quantita,
          qta_sconto_merce,qta_evasa,fat_con_unita_base,fat_con_globale,
          qta_un_base,qta_evasa_un_base,id_caus_magazzino,id_locazione_1,id_locazione_2,
          id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
          sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
          peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
          provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
          sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
          tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
          id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
          provv_imp_subage,provv_imp_carea,id_riga_lotto,
          qta_ordinata_fo,ordinato_fo,peso_netto_evaso,id_gruppo_Agenti_2,
          provv_agente_2,provv_subage_2,provv_carea_2,
          provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2)
          select @li_id_documento_new,id_unita_confezione,id_gruppo_agenti,
            num_riga,id_articolo,descrizione,id_des_articolo,quantita,
            qta_sconto_merce,qta_evasa,fat_con_unita_base,fat_con_globale,
            qta_un_base,qta_evasa_un_base,@ai_id_caus_mag,id_locazione_1,id_locazione_2,
            id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
            sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
            peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
            provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
            sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
            tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
            id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
            provv_imp_subage,provv_imp_carea,id_riga_lotto,
            qta_ordinata_fo,ordinato_fo,peso_netto_evaso,id_gruppo_Agenti_2,
            provv_agente_2,provv_subage_2,provv_carea_2,
            provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2
            from riga_documento
            where id_documento=@ai_id_documento order by
            num_riga asc
       else           
        insert into riga_documento(id_documento,id_unita_confezione,id_gruppo_agenti,
          num_riga,id_articolo,descrizione,id_des_articolo,quantita,
          qta_sconto_merce,qta_evasa,fat_con_unita_base,fat_con_globale,
          qta_un_base,qta_evasa_un_base,id_caus_magazzino,id_locazione_1,id_locazione_2,
          id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
          sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
          peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
          provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
          sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
          tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
          id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
          provv_imp_subage,provv_imp_carea,id_riga_lotto,
          qta_ordinata_fo,ordinato_fo,peso_netto_evaso,id_gruppo_Agenti_2,
          provv_agente_2,provv_subage_2,provv_carea_2,
          provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2)
          select @li_id_documento_new,id_unita_confezione,id_gruppo_agenti,
            num_riga,id_articolo,descrizione,id_des_articolo,quantita,
            qta_sconto_merce,qta_evasa,fat_con_unita_base,fat_con_globale,
            qta_un_base,qta_evasa_un_base,@ai_id_caus_mag,@li_id_locazione_1_prop,id_locazione_2,
            id_valuta,cambio,id_listino,id_con_lis_articolo,prezzo,
            sconto,prezzo_netto,sconto_riga,data_prevista_consegna,peso_netto,
            peso_lordo,dim_l,dim_h,dim_p,num_colli,id_tab_iva,val_attribuito,
            provv_agente,provv_subage,provv_carea,id_caus_trasporto,forza_chius_evasione,
            sospesa,da_stampare,data_inizio_competenza,data_fine_competenza,
            tot_riga_val_riga,tot_riga_val_doc,tot_riga_val_az, //id_riga_doc_provenienza,
            id_conto,id_azienda,id_riga_doc_padre,provv_imp_agente,
            provv_imp_subage,provv_imp_carea,id_riga_lotto,
            qta_ordinata_fo,ordinato_fo,peso_netto_evaso,id_gruppo_Agenti_2,
            provv_agente_2,provv_subage_2,provv_carea_2,
            provv_imp_agente_2,provv_imp_subage_2,provv_imp_carea_2
            from riga_documento
            where id_documento=@ai_id_documento order by
            num_riga asc
        end if
  end if
  ;
  set @ls_sqlstate=sqlstate;
  message 'Righe Documento ...';
  if(@ls_sqlstate='00000') then
    message ' OK'
  else
    message '   Si e'' verificato un errore inserendo le righe del documento - SQLSTATE:'+@ls_sqlstate;
    return 0
  end if
  ;
  //
  //  CASTELLETTO IVA
  //
  insert into cast_iva_documento(id_documento,id_tab_iva,val_omaggi,val_imponibile,
    val_imp_scontato,val_spese,val_tot_imp_v,val_tot_imp_l,val_tot_iva_v,val_tot_iva_l)
    select @li_id_documento_new,id_tab_iva,val_omaggi,val_imponibile,val_imp_scontato,
      val_spese,val_tot_imp_v,val_tot_imp_l,val_tot_iva_v,val_tot_iva_l
      from cast_iva_documento
      where id_documento=@ai_id_documento;
  //
  //  CASTELLETTO CONTROPARTITA
  //      
  insert into cast_cpt_documento(id_documento,id_conto,tipo_riga_cpt,
    val_imponibile,val_imp_scontato,val_omaggi,val_spese)
    select @li_id_documento_new,id_conto,tipo_riga_cpt,
      val_imponibile,val_imp_scontato,val_omaggi,val_spese
      from cast_cpt_documento
      where id_documento=@ai_id_documento;
  //
  //  SCADENZE
  //          
  //insert into scadenza(tipo_scadenza,id_sog_commerciale,data_scadenza,
  //  id_valuta,cambio,imp_valuta,importo,id_tipo_pagamento,id_banca_azienda,
  //  id_banca_sog_commerciale,note,ces_denominazione,ces_indirizzo,
  //  ces_cap,ces_localita,ces_provincia,ces_doc_originale,ces_data_documento,
  //  stato_scadenza,data_cambiamento_stato,esito_pagamento,scadenza_da_raggruppare,
  //  id_riga_distinta_banca,id_documento,id_par_aperta,id_scadenza_padre,id_azienda)
  //  select tipo_scadenza,id_sog_commerciale,data_scadenza,
  //    id_valuta,cambio,imp_valuta,importo,id_tipo_pagamento,id_banca_azienda,
  //    id_banca_sog_commerciale,note,ces_denominazione,ces_indirizzo,
  //    ces_cap,ces_localita,ces_provincia,ces_doc_originale,ces_data_documento,
  //    stato_scadenza,data_cambiamento_stato,esito_pagamento,scadenza_da_raggruppare,
  //    id_riga_distinta_banca,@li_id_documento_new,id_par_aperta,id_scadenza_padre,id_azienda
  //    from scadenza
  //   where id_documento=@ai_id_documento;
  return(@li_id_documento_new)
end;
///////////////////////////////////////////////////////////////

//velocizzare partite
IF not EXISTS(
        SELECT 1 from sysforeignkey  where role='FK_MOV_SCAD') THEN

ALTER TABLE "DBA"."mov_scadenza"
	ADD FOREIGN KEY "FK_MOV_SCAD" ("id_scadenza") 
	REFERENCES "DBA"."scadenza" ("id_scadenza")

END IF;


call fn_ins_voce_menu('Listini', 'w_impexp_list_cx', 'Esporta Listino con Condizioni', 150);

/////////CORTONESE proposta lotto e data precedente
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
                  AND      CNAME = 'prop_lotto_data' )) THEN 
        alter table pers_par_sistema add "prop_lotto_data" char(1) DEFAULT NULL;          
end if;
///////////////////////////////////////////////////

/////////BRIGANTI Stampa doc. su laser personalizzata
IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'pers_par_sistema'
                  AND      CNAME = 'stdoc_copie' )) THEN 
        alter table pers_par_sistema add "stdoc_copie" char(1) DEFAULT NULL;          
end if;

IF NOT(EXISTS(
        SELECT 1 
        FROM   SYS.SYSCOLUMNS
        WHERE  TNAME = 'prof_documento'
                  AND      CNAME = 'stdoc_copie' )) THEN 
        alter table prof_documento add "stdoc_copie" char(1) DEFAULT NULL;          
end if;
///////////////////////////////////////////////////


/*Questa  l'ultima operazione dello script che aggiorna la tabella degli aggiornamenti*/
IF NOT(EXISTS(
        SELECT 1 
   FROM   script
   WHERE  codice = '2_01_003' )) THEN

        insert into script (codice,note,eseguito)
        values ('2_01_003','Release 2_01_003  Cometa','S')
        ;

END IF
;

